import pytest
import sys
import os
# Add the src directory to the Python path
src_dir = os.path.abspath(os.path.join(os.path.dirname(__file__), '..', '..', 'src'))
sys.path.insert(0, src_dir)

from models.provider import Provider
from models.data import TextData  # Assuming this is the class used for text_data_list

def test_provider_init():
    title = "Test Provider"
    count = 10
    text_data_list = [TextData(is_fake_news=True), TextData(is_fake_news=False)]
    provider = Provider(title, count, text_data_list)

    assert provider.title == title
    assert provider.count == count
    assert provider.text_data_list == text_data_list

def test_get_fake_percentage():
    text_data_list = [TextData(is_fake_news=False), TextData(is_fake_news=False), TextData(is_fake_news=True)]
    provider = Provider("Test Provider", 10, text_data_list)

    assert provider.get_fake_percentage() == 33.33

def test_get_fake_percentage_zero_division():
    text_data_list = []
    provider = Provider("Test Provider", 10, text_data_list)

    assert provider.get_fake_percentage() == 0.0

        
if __name__ == "__main__":
    pytest.main([__file__])
